#!/usr/bin/perl -w
#
# AVR based RGB Moodlight
#
# table.pl - create a (semi)logarithmic pwm table
#
# (c) Axel (XL) Schwenke, axel.schwenke@gmx.net
#
# $Id: table.pl 141 2012-01-11 18:01:20Z schwenke $

my $start    = 65536; #timer cycle length = 100%
my $mindelta = 61;    #minimum time between compare matches
my $factor   = 1.02;  #factor between steps

my $step = 0;
my @table = ();

while ($step < 256 && $start >= $mindelta) {
    push @table, int($start+0.499);
    my $new = $start / $factor;
    if ($start - $new < $mindelta) {
        $start -= $mindelta;
    } else {
        $start = $new;
    }
    $step++;
}

print  "------\n";
printf  "/* generated pwm table; factor=%f, mindelta=%d */\n\n",
    $factor, $mindelta;
printf "#define MAX_BRIGHT %d\n", $step;
printf "uint16_t pwmtable[MAX_BRIGHT+1] PROGMEM = {\n\t0";
while ($step = pop @table) {
    printf ", %d", ($step % 65536);
}
print "\n};\n------\n";

